package com.zswl.cloud.springBtach.server.core.controller;

import com.github.microservice.auth.client.content.ResultContent;
import com.xiaoju.open.oil.commons.OilRequest;
import com.xiaoju.open.oil.core.executor.ResponseDTO;
import com.xiaoju.open.oil.interfaces.request.NotificationPushStoreInfoRequest;
import com.xiaoju.open.oil.interfaces.response.QueryStoreDetailResponse;
import com.zswl.cloud.springBtach.server.core.service.XiaoJuService;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@Log4j2
@RestController
@RequestMapping("xiaoju")
public class XiaoJuController {

    @Autowired
    XiaoJuService xiaoJuService;

    @ApiOperation("同步加油站信息")
    @RequestMapping(value = "receivingGasStation", method = RequestMethod.POST)
    public ResponseDTO receivingGasStation(@RequestBody OilRequest oilRequest) {

        return xiaoJuService.notificationPushStoreInfoRequest(oilRequest);
    }
    @ApiOperation("查看加油站详情")
    @RequestMapping(value = "queryStoreDetail", method = RequestMethod.POST)
    public ResultContent<QueryStoreDetailResponse> queryStoreDetail(String storeId) {

        return xiaoJuService.queryStoreDetail(storeId);
    }


}
