package com.zswl.cloud.springBtach.server.core.service;


import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.github.microservice.auth.client.content.ResultContent;
import com.github.microservice.auth.security.helper.AuthHelper;
import com.xiaoju.open.oil.commons.OilRequest;
import com.xiaoju.open.oil.commons.config.OilConfig;
import com.xiaoju.open.oil.core.QueryClient;
import com.xiaoju.open.oil.core.QueryClientFactory;
import com.xiaoju.open.oil.core.executor.ResponseDTO;
import com.xiaoju.open.oil.interfaces.request.NotificationPushStoreInfoRequest;
import com.xiaoju.open.oil.interfaces.request.QueryStoreDetailRequest;
import com.xiaoju.open.oil.interfaces.response.QueryStoreDetailResponse;
import com.xiaoju.open.oil.security.secret.SecurityService;
import com.zswl.cloud.springBtach.server.core.dao.XiaoJuStoreDao;
import com.zswl.cloud.springBtach.server.core.domain.XiaoJuStore;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class XiaoJuService {


    private static final Logger log = LoggerFactory.getLogger(XiaoJuService.class);
    @Autowired
    AuthHelper authHelper;

    @Autowired
    XiaoJuStoreDao xiaoJuStoreDao;

    @Autowired
    OilConfig oilConfig;

    // 查询加油站详情
    public ResponseDTO notificationPushStoreInfoRequest(OilRequest oilRequest){

        log.info("加油站通知原始数据：{}", oilRequest);

        String s = SecurityService.genDecodeData(oilRequest.getData(), oilConfig.getDataSecret(), oilConfig.getDataSecretIV());

        log.info("通知 加油站详情：{}", s);
        XiaoJuStore xiaoJuStore = JSONUtil.toBean(s, XiaoJuStore.class);

        XiaoJuStore byStoreId = xiaoJuStoreDao.findByStoreId(xiaoJuStore.getStoreId());
        if(byStoreId != null){
            BeanUtils.copyProperties(oilRequest, byStoreId,"id","updateTime");
        }

        xiaoJuStoreDao.save(xiaoJuStore);
        ResponseDTO responseDTO = new ResponseDTO();
        responseDTO.setAppKey(oilConfig.getAppId());
        responseDTO.setCode("0");
        responseDTO.setMsg("请求成功");
        responseDTO.setData("heO67plAls2+P9bo/7XJnHz77N8W+WyCP37/COPLr3k=");
        responseDTO.setSig("B1445B2A12037FADFCD6FAE6D83ECB9A");
        return responseDTO;

    }

    public ResultContent<QueryStoreDetailResponse> queryStoreDetail(String storeId) {
        XiaoJuStore byStoreId = xiaoJuStoreDao.findByStoreId(storeId);
        QueryStoreDetailRequest queryStoreDetailRequest = new QueryStoreDetailRequest();

        queryStoreDetailRequest.setOutUserId(authHelper.getCurrentUser().getUserId());
        queryStoreDetailRequest.setStoreId(storeId);
        queryStoreDetailRequest.setLat(byStoreId.getLat());
        queryStoreDetailRequest.setLon(byStoreId.getLon());
        queryStoreDetailRequest.setOpenChannel(1);

        QueryClient queryClient = QueryClientFactory.create(oilConfig);

        QueryStoreDetailResponse queryStoreDetailResponse = queryClient.api().queryStoreDetail(queryStoreDetailRequest);

        return ResultContent.buildContent(queryStoreDetailResponse);
    }









}
